// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use crate::FuzzyIndex;
use glib::{prelude::*, translate::*};
use std::fmt;

glib::wrapper! {
    #[doc(alias = "DzlFuzzyIndexCursor")]
    pub struct FuzzyIndexCursor(Object<ffi::DzlFuzzyIndexCursor, ffi::DzlFuzzyIndexCursorClass>) @implements gio::ListModel;

    match fn {
        type_ => || ffi::dzl_fuzzy_index_cursor_get_type(),
    }
}

impl FuzzyIndexCursor {
    #[doc(alias = "dzl_fuzzy_index_cursor_get_index")]
    #[doc(alias = "get_index")]
    pub fn index(&self) -> Option<FuzzyIndex> {
        unsafe { from_glib_none(ffi::dzl_fuzzy_index_cursor_get_index(self.to_glib_none().0)) }
    }

    #[doc(alias = "case-sensitive")]
    pub fn is_case_sensitive(&self) -> bool {
        ObjectExt::property(self, "case-sensitive")
    }

    #[doc(alias = "max-matches")]
    pub fn max_matches(&self) -> u32 {
        ObjectExt::property(self, "max-matches")
    }

    pub fn query(&self) -> Option<glib::GString> {
        ObjectExt::property(self, "query")
    }
}

impl fmt::Display for FuzzyIndexCursor {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        f.write_str("FuzzyIndexCursor")
    }
}
